/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import java.util.Locale;

import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_QuadrantLocationFromBI_RADS;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;


/**
 * This class represents QuadrantLocation - CID6020
 */
public class QuadrantLocation_CID6020 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	
	/**
	 * The Coding Scheme Version
	 */
	private String strCodingSchemeVersion = null;

	/**
	 * Object of QuadrantLocationFromBI_RADS_CID6021
	 */
	private QuadrantLocationFromBI_RADS_CID6021 objQuadrantLocationFromBIRADSCID6021;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;	
	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for CodingSchemeVersion
	 * @return
	 */
	public String getCodingSchemeVersion() {
		return strCodingSchemeVersion;
	}
	
	/**
	 * Instantiates a new QuadrantLocation_CID6020 Template 
	 */
	public QuadrantLocation_CID6020()
	{

	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the value for Quadrant Location
	 * @param enumQuadrantLocationFromBI_RADS This value can be Enum - EnumCM_QuadrantLocationFromBI_RADS.
	 */
	public void setQuadrantLocation(EnumCM_QuadrantLocationFromBI_RADS enumQuadrantLocationFromBI_RADS)
	{
//					
			/**
			 * Creating object of require CID with respect to enum and setting value accordingly.
			 */
			if(null== this.objQuadrantLocationFromBIRADSCID6021)
	{this.objQuadrantLocationFromBIRADSCID6021 = new QuadrantLocationFromBI_RADS_CID6021();
			this.objQuadrantLocationFromBIRADSCID6021.setQuadrantLocationFromBI_RADS(enumQuadrantLocationFromBI_RADS);
			
			/**
			 * Retrieving attributes and setting it to member variables. 
			 */
			this.strCodeMeaning = objQuadrantLocationFromBIRADSCID6021.getCodeMeaning();
			this.strCodeValue = objQuadrantLocationFromBIRADSCID6021.getCodeValue();
			this.strCodingSchemeDesignator = objQuadrantLocationFromBIRADSCID6021.getCodingSchemeDesignator();
			this.strCodingSchemeVersion = objQuadrantLocationFromBIRADSCID6021.getCodingSchemeVersion();
			this.strSNOMEDCTID = objQuadrantLocationFromBIRADSCID6021.getSNOMEDCTID();
		}
		else
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger objDicomLogger = DicomLogger.getLogger();
			objDicomLogger.log(ResourceBundleWrapper.getValue("warning","InvalidEnumeratedValue",new Locale(DicomConfig.createInstance().getLocale())));
		}
	}
	}
}
